#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------
# Hydra Benchmarks: report.py
#
# (C) 2023 Statistics Canada
# Author: Saptarshi Dutta Gupta
# ------------------------------------------------------------
import pandas as pd
from enum import Enum
from typing import Dict, Tuple
from dsd.hydra.benchmarks.models.compare_schema import CompareOutput
from pydantic import BaseModel


class ReportData(BaseModel):
    metrics_per_subset: pd.DataFrame
    metrics_per_file: pd.DataFrame
    header_df: pd.DataFrame
    render_dict: Dict[str, Dict[str, Dict[str, float]]]

    class Config:
        arbitrary_types_allowed = True


class Label(Enum):
    iou_thr = "IOU Threshold"
    precision = "Precision"
    recall = "Recall"
    f1 = "F1 Score"
    subset = "Subset"
    algorithm = "Algorithm"
    region_counts = "Regions Count"
    text_accuracy = "Text Accuracy"
    cer = "Character Error Rate"
    filename = "Filename"
    summary_report = "Summary Report"
    detailed_report = "Detailed Report"
    title = "Hydra CLI Report"
    exec_time = "Execution Time: {exec_time}"
    subset_index = "Subset {index}: {total}"
    algorithm_index = "Algorithm {index}: {total}"


class Column(Enum):
    dataset = "Dataset"
    version = "Version"
    algorithms = "Algorithm(s)"
    subset = "Subset(s)"
    total_exec_time = "Total Execution Time"


class SessionKey(Enum):
    session = "session"
    filename = "filename"


class SummaryKey(Enum):
    exec_time = "exec_time"


class SummaryType(Enum):
    detailed = "detailed"
    summary = "summary"


def get_run_info(
    detection_file: CompareOutput,
) -> Tuple[pd.DataFrame, Dict[str, Dict[str, Dict[str, float]]]]:
    """
    Gathers the required data from the detection file
    Arguments:
        - detection_file (CompareOutput) : the detection file generated
                                           by the compare command

    Returns:
        - header_df(pd.DataFrame): header dataframe containing the dataset,
                                   version, algorithm, subset and execution time
        - ender_dict(Dict[str, int]): a dictionary of summary
                                      information used to render the tables
    """
    dataset = detection_file.output[0].dataset
    version = detection_file.output[0].version

    algorithms = [output.name for output in detection_file.output]
    subsets = [output.subset for output in detection_file.output]

    separator = ", "
    algorithms = separator.join(algorithms)
    subsets = separator.join(subsets)

    render_dict = {
        algorithm.name: {
            algorithm.subset: {SummaryKey.exec_time.value: algorithm.subset_exec_time}
        }
        for algorithm in detection_file.output
    }
    total_exec_time = sum(
        subset[SummaryKey.exec_time.value]
        for algorithm in render_dict.values()
        for subset in algorithm.values()
    )

    header_data = {
        Column.dataset.value: [dataset],
        Column.version.value: [version],
        Column.algorithms.value: [algorithms],
        Column.subset.value: [subsets],
        Column.total_exec_time.value: [total_exec_time],
    }
    header_df = pd.DataFrame(header_data)
    return header_df, render_dict


def get_metrics(detection_file: CompareOutput) -> Tuple[pd.DataFrame, pd.DataFrame]:
    """
    Consolidates the metrics per subset and file into
    a DataFrame for further processing by the Dash app
    Arguments:
        - detection_file (CompareOutput): the output generated by the compare command
    Returns:
        - metrics_per_subset (pd.DataFrame): a DataFrame with all the metrics per subset
        - metrics_per_file (pd.DataFrame): a DataFrame with all the metrics per file
    """

    metrics_per_subset = pd.DataFrame()
    metrics_per_file = pd.DataFrame()
    for algorithm in detection_file.output:
        # get the metrics per subset

        metrics_list = [
            {
                Label.algorithm.value: algorithm.name,
                Label.subset.value: algorithm.subset,
                Label.iou_thr.value: metrics.iou,
                Label.precision.value: metrics.detection.p,
                Label.recall.value: metrics.detection.r,
                Label.f1.value: metrics.detection.f1,
                Label.region_counts.value: metrics.detection.rc,
                Label.text_accuracy.value: metrics.quality.ta,
                Label.cer.value: metrics.quality.cer,
            }
            for metrics in algorithm.subset_metrics
        ]

        metrics_per_subset = pd.concat([metrics_per_subset, pd.DataFrame(metrics_list)])

        # get the metrics per file
        metrics_list = [
            {
                Label.algorithm.value: algorithm.name,
                Label.subset.value: algorithm.subset,
                Label.iou_thr.value: metrics.iou,
                Label.filename.value: file.name,
                Label.precision.value: metrics.detection.p,
                Label.recall.value: metrics.detection.r,
                Label.f1.value: metrics.detection.f1,
                Label.region_counts.value: metrics.detection.rc,
                Label.text_accuracy.value: metrics.quality.ta,
                Label.cer.value: metrics.quality.cer,
            }
            for file in algorithm.files
            for metrics in file.file_metrics
        ]

        metrics_per_file = pd.concat([metrics_per_file, pd.DataFrame(metrics_list)])

    return metrics_per_subset, metrics_per_file
